// ignore_for_file: non_constant_identifier_names

import "dart:math";

import "map.dart" as mapext;
import "regexp.dart" as regexp;

extension GeneralLibExtensionList on List {
  List<List<T>> createLimit<T>({
    required int limit,
  }) {
    List<List<T>> result = [];
    List<T> state_data = [];
    for (var i = 0; i < length; i++) {
      dynamic data_id = this[i];
      if (data_id is T == false) {
        continue;
      }
      if (state_data.length >= limit) {
        state_data.add(data_id);
        result.add(state_data);
        state_data = [];
      } else {
        state_data.add(data_id);
      }
    }
    if (state_data.isNotEmpty) {
      result.add(state_data);
      state_data = [];
    }
    return result;
  }

  List<T> clone<T>() {
    List<T> jsonData = [];

    for (var i = 0; i < length; i++) {
      T data_loop = this[i];
      if (data_loop is Map) {
        jsonData.add(data_loop.clone() as T);
      } else if (data_loop is List) {
        jsonData.add(data_loop.clone() as T);
      } else {
        jsonData.add(data_loop);
      }
    }
    return jsonData;
  }

  bool hashData(List datas) {
    int count_valid = 0;
    int count_data_same = 0;

    void countValids(List data_origins) {
      for (var i = 0; i < data_origins.length; i++) {
        dynamic value = data_origins[i];
        if (value is Map) {
          count_valid++;
        } else if (value is List) {
          countValids(value);
        } else {
          count_valid++;
        }
      }
    }

    for (var i = 0; i < datas.length; i++) {
      dynamic value = datas[i];
      if (value is Map) {
        count_valid++;
      } else if (value is List) {
        countValids(value);
      } else {
        count_valid++;
      }
    }

    void countSame(List data_origin, List data_old) {
      int count_length = data_old.length;
      for (var i = 0; i < data_origin.length; i++) {
        if (i >= count_length) {
          continue;
        }
        dynamic value = datas[i];
        dynamic value_origin = data_origin[i];
        if (value is RegExp) {
          if (value.hashData(value_origin)) {
            count_data_same++;
          }
        } else if (value is Map) {
          if (value_origin is Map) {
            if (value_origin.hashData(value)) {
              count_data_same++;
            }
          }
        } else if (value is List) {
          if (value_origin is List) {
            countSame(value_origin, value);
          }
        } else {
          if (value_origin == value) {
            count_data_same++;
          }
        }
      }
    }

    int count_length = length;
    for (var i = 0; i < datas.length; i++) {
      if (i >= count_length) {
        continue;
      }
      dynamic value = datas[i];
      dynamic value_origin = this[i];
      if (value is RegExp) {
        if (value.hashData(value_origin)) {
          count_data_same++;
        }
      } else if (value is Map) {
        if (value_origin is Map) {
          if (value_origin.hashData(value)) {
            count_data_same++;
          }
        }
      } else if (value is List) {
        if (value_origin is List) {
          countSame(value_origin, value);
        }
      } else {
        if (value_origin == value) {
          count_data_same++;
        }
      }
    }

    if (count_valid == 0) {
      return false;
    }
    return (count_valid == count_data_same);
  }

  T? get<T>(dynamic data) {
    for (var index = 0; index < length; index++) {
      T data_origin = this[index];
      if (data is Map && data_origin is Map) {
        if (data_origin.hashData(data)) {
          return data_origin;
        }
      } else if (data is List && data_origin is List) {
        if (data_origin.hashData(data)) {
          return data_origin;
        }
      } else if (data == data_origin) {
        return data_origin;
      }
    }
    return null;
  }

  List<T> gets<T>(dynamic data) {
    List<T> datas = [];
    for (var index = 0; index < length; index++) {
      T data_origin = this[index];
      if (data is Map && data_origin is Map) {
        if (data_origin.hashData(data)) {
          datas.add(data_origin);
        }
      } else if (data is List && data_origin is List) {
        if (data_origin.hashData(data)) {
          datas.add(data_origin);
        }
      } else if (data == data_origin) {
        datas.add(data_origin);
      }
    }
    return datas;
  }

  List<T> cloneAndRandom<T>(List<T> array) {
    List<T> random_datas = [];
    for (var index = 0; index < array.length; index++) {
      random_datas.add(array[index]);
    }
    for (var index = 0; index < random_datas.length; index++) {
      random_datas.shuffle();
    }
    return random_datas;
  }

  T? random<T>({
    required T Function() onNotFound,
  }) {
    try {
      return (this[Random().nextInt(length)] as T);
    } catch (e) {
      return onNotFound();
    }
  }

  T? randomOrNull<T>() {
    try {
      return (this[Random().nextInt(length)] as T);
    } catch (e) {
      return null;
    }
  }
}

extension GeneralLibRegExpExtensionList on List<RegExp> {
  bool hashData(dynamic input) {
    for (var i = 0; i < length; i++) {
      RegExp regExp = this[i];
      if (regExp.hashData(input)) {
        return true;
      }
    }
    return false;
  }
}
